VERSION 5.00
Begin VB.Form Form1 
   ClientHeight    =   2535
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7560
   LinkTopic       =   "Form1"
   ScaleHeight     =   2535
   ScaleWidth      =   7560
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SelectClipPath Lib "gdi32" (ByVal hdc As Long, ByVal iMode As Long) As Long
Private Declare Function BeginPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function EndPath Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function PathToRegion Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hWnd As Long, ByVal hRgn As Long, ByVal bRedraw As Boolean) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long

Private Const RGN_OR = 2

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Private Const FW_DONTCARE = 0
Private Const FW_THIN = 100
Private Const FW_EXTRALIGHT = 200
Private Const FW_ULTRALIGHT = 200
Private Const FW_LIGHT = 300
Private Const FW_NORMAL = 400
Private Const FW_REGULAR = 400
Private Const FW_MEDIUM = 500
Private Const FW_SEMIBOLD = 600
Private Const FW_DEMIBOLD = 600
Private Const FW_BOLD = 700
Private Const FW_EXTRABOLD = 800
Private Const FW_ULTRABOLD = 800
Private Const FW_HEAVY = 900
Private Const FW_BLACK = 900

Private Type Size
    cx As Long
    cy As Long
End Type
Private Declare Function GetTextExtentPoint Lib "gdi32" Alias "GetTextExtentPointA" (ByVal hdc As Long, ByVal lpszString As String, ByVal cbString As Long, lpSize As Size) As Long
Private Declare Function StrokePath Lib "gdi32" (ByVal hdc As Long) As Long

Private Type TEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
End Type
Private Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" (ByVal hdc As Long, lpMetrics As TEXTMETRIC) As Long
' Shape the form.
Private Sub ShapeForm()
Const TEXT1 = "RAD"
Const TEXT2 = "VB"
Const TEXT_HGT = 250
Const TEXT_WID = 100
Const FONT_NAME = "Times New Roman"
Const GAP = -80
Const DRAW_WIDTH = 5

Dim new_font As Long
Dim old_font As Long
Dim hRgn As Long
Dim sz As Size
Dim wid As Single
Dim hgt As Single
Dim pix_wid As Single
Dim pix_hgt As Single
Dim text1_wid As Single
Dim text1_hgt As Single
Dim text2_wid As Single
Dim text2_hgt As Single
Dim x1 As Long
Dim y1 As Long
Dim x2 As Long
Dim y2 As Long

    ' Prepare the form.
    AutoRedraw = True
    ScaleMode = vbPixels
    BorderStyle = vbBSNone
    BackColor = vbBlue
    ForeColor = vbBlack
    Caption = ""
    DrawWidth = DRAW_WIDTH
    ' ControlBox = False    ' Set at design time.
    ' MinButton = False     ' Set at design time.
    ' MaxButton = False     ' Set at design time.
    ' ShowInTaskbar = False ' Set at design time.

    ' Create the custom font.
    new_font = CustomFont(TEXT_HGT, TEXT_WID, 0, 0, _
        FW_BOLD, False, False, False, _
        FONT_NAME)
    old_font = SelectObject(hdc, new_font)

    ' Get the size of the first string.
    GetTextExtentPoint hdc, TEXT1, Len(TEXT1), sz
    text1_wid = sz.cx
    text1_hgt = sz.cy

    ' Get the size of the second string.
    GetTextExtentPoint hdc, TEXT2, Len(TEXT2), sz
    text2_wid = sz.cx
    text2_hgt = sz.cy

    ' Make the form big enough.
    If text1_wid > text2_wid Then
        wid = text1_wid
    Else
        wid = text2_wid
    End If
    hgt = text1_hgt + text2_hgt + GAP

    pix_wid = ScaleX(wid, vbPixels, vbTwips)
    pix_hgt = ScaleY(hgt, vbPixels, vbTwips)
    Move (Screen.Width - pix_wid) / 2, _
         (Screen.Height - pix_hgt) / 2, _
         pix_wid, pix_hgt

    ' Position the text.
    x1 = (wid - text1_wid) / 2
    y1 = 0
    x2 = (wid - text2_wid) / 2
    y2 = text1_hgt + GAP

    ' Make the region.
    BeginPath hdc
    CurrentX = x1
    CurrentY = y1
    Print TEXT1
    CurrentX = x2
    CurrentY = y2
    Print TEXT2
    EndPath hdc
    hRgn = PathToRegion(hdc)

    ' Constrain the form to the combined region.
    SetWindowRgn hWnd, hRgn, False

    ' Draw the text again with a hollow font.
    BeginPath hdc
    CurrentX = x1
    CurrentY = y1
    Print TEXT1
    CurrentX = x2
    CurrentY = y2
    Print TEXT2
    EndPath hdc
    StrokePath hdc

    ' Restore the original font.
    SelectObject hdc, old_font

    ' Free font resources (important!)
    DeleteObject new_font
End Sub

' Make a customized font and return its handle.
Private Function CustomFont(ByVal hgt As Long, ByVal wid As Long, ByVal escapement As Long, ByVal orientation As Long, ByVal wgt As Long, ByVal is_italic As Long, ByVal is_underscored As Long, ByVal is_striken_out As Long, ByVal face As String) As Long
Const CLIP_LH_ANGLES = 16   ' Needed for tilted fonts.

    CustomFont = CreateFont( _
        hgt, wid, escapement, orientation, wgt, _
        is_italic, is_underscored, is_striken_out, _
        0, 0, CLIP_LH_ANGLES, 0, 0, face)
End Function


Private Sub Form_Load()
    ' Shape the form.
    ShapeForm
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Unload Me
End Sub


